#!/opt/bin/perl
use RRD::Simple;
use strict;
use Data::Dumper;


my $rrd_file="/volume1/opt/rrd/strom.rrd";
my $lck_file=$rrd_file."_lck";


# Create an interface object
my $rrd = RRD::Simple->new(
        file => $rrd_file,
        cf => [qw(LAST AVERAGE MIN MAX)],
        default_dstype => "COUNTER",
        on_missing_ds => "add",
         );

if (!-f $rrd_file) {
	$rrd->create( $rrd_file, "3years", "Strom"=>"GAUGE", "Strom_data"=>"COUNTER");
}


    open my $in, "/opt/bin/wget -q -O - http://192.168.178.222/strom_csv.html|" or die $!;

    my @data=();
    while(<$in>){
	chomp();
	my ($num,$ds,$power) = split(/;/);
	push @data, [$ds,$power];
    }

print Dumper(\@data);
if(scalar(@data)) {
	$rrd->update(map { $_->[0]=>$_->[1] } @data );
}

