#!/opt/bin/perl
use RRD::Simple;
use strict;


my $rrd_file="/volume1/opt/rrd/temperatur.rrd";

# Create an interface object
my $rrd = RRD::Simple->new(
        file => $rrd_file,
        cf => [qw(LAST AVERAGE MIN MAX)],
        default_dstype => "GAUGE",
        on_missing_ds => "add",
         );


my @temp;
my $try_again = 3;
while ($try_again > 0 && $try_again < 5 ) {
    open my $in, "/opt/bin/wget -q -O - http://192.168.178.222/csv.html|" or die $!;

    $try_again = 0;
# Return information about an RRD file
    my $info = $rrd->info;

    @temp=();
    while(<$in>){
	chomp();
	my ($num,$ort,$temperatur) = split(/;/);
	my $alt = $info->{ds}->{$ort}->{last_ds};
	if ( $alt ne "U" && abs($alt - $temperatur) > 20) {
	    print STDERR "Peek in Temp $ort: von $alt auf $temperatur, try again\n";
	    $try_again++;
	} else {
	    push @temp, [$ort,$temperatur];
	}
    }
}

if (!-f $rrd_file) {
	$rrd->create( $rrd_file, "3years", map { $_->[0] => "GAUGE" } @temp);
}

$rrd->update(map { $_->[0]=>$_->[1] } @temp );
